## org.codehaus.groovy.grails.web.json
Class JSONTokener

    java.lang.Object
      org.codehaus.groovy.grails.web.json.JSONTokener

    public class JSONTokener

extends Object

A JSONTokener takes a source string and extracts characters and tokens from it. It is used by the JSONObject and JSONArray constructors to parse JSON source strings.

Version:
  2
Author:
  JSON.org

Constructor Summary
`JSONTokener(String s)` Construct a JSONTokener from a string.

Method Summary
`void` `back()` Back up one character.
`static int` `dehexchar(char c)` Get the hex value of a character (base16).
`boolean` `more()` Determine if the source string still contains characters that next() can consume.
`char` `next()` Get the next character in the source string.
`char` `next(char c)` Consume the next character, and check that it matches a specified character.
`String` `next(int n)` Get the next n characters.
`char` `nextClean()` Get the next char in the string, skipping whitespace and comments (slashslash, slashstar, and hash).
`String` `nextString(char quote)` Return the characters up to the next close quote character.
`String` `nextTo(char d)` Get the text up but not including the specified character or the end of line, whichever comes first.
`String` `nextTo(String delimiters)` Get the text up but not including one of the specified delimeter characters or the end of line, whichever comes first.
`Object` `nextValue()` Get the next value.
`void` `skipPast(String to)` Skip characters until past the requested string.
`char` `skipTo(char to)` Skip characters until the next character is the requested character.
`JSONException` `syntaxError(String message)` Make a JSONException to signal a syntax error.
`String` `toString()` Make a printable string of this JSONTokener.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### JSONTokener

    public JSONTokener(String s)

  Construct a JSONTokener from a string.

  Parameters:
    `s` - A source string.

Method Detail

### back

    public void back()

  Back up one character. This provides a sort of lookahead capability, so that you can test for a digit or letter before attempting to parse the next number or identifier.

### dehexchar

    public static int dehexchar(char c)

  Get the hex value of a character (base16).

  Parameters:
    `c` - A character between '0' and '9' or between 'A' and 'F' or between 'a' and 'f'.
  Returns:
    An int between 0 and 15, or -1 if c was not a hex digit.

### more

    public boolean more()

  Determine if the source string still contains characters that next() can consume.

  Returns:
    true if not yet at the end of the source.

### next

    public char next()

  Get the next character in the source string.

  Returns:
    The next character, or 0 if past the end of the source string.

### next

    public char next(char c)
              throws JSONException

  Consume the next character, and check that it matches a specified character.

  Parameters:
    `c` - The character to match.
  Returns:
    The character.
  Throws:
    `JSONException` - if the character does not match.

### next

    public String next(int n)
                throws JSONException

  Get the next n characters.

  Parameters:
    `n` - The number of characters to take.
  Returns:
    A string of n characters.
  Throws:
    `JSONException` - Substring bounds error if there are not n characters remaining in the source string.

### nextClean

    public char nextClean()
                   throws JSONException

  Get the next char in the string, skipping whitespace and comments (slashslash, slashstar, and hash).

  Returns:
    A character, or 0 if there are no more characters.
  Throws:
    `JSONException`

### nextString

    public String nextString(char quote)
                      throws JSONException

  Return the characters up to the next close quote character. Backslash processing is done. The formal JSON format does not allow strings in single quotes, but an implementation is allowed to accept them.

  Parameters:
    `quote` - The quoting character, either `"` (double quote) or `'` (single quote).
  Returns:
    A String.
  Throws:
    `JSONException` - Unterminated string.

### nextTo

    public String nextTo(char d)

  Get the text up but not including the specified character or the end of line, whichever comes first.

  Parameters:
    `d` - A delimiter character.
  Returns:
    A string.

### nextTo

    public String nextTo(String delimiters)

  Get the text up but not including one of the specified delimeter characters or the end of line, whichever comes first.

  Parameters:
    `delimiters` - A set of delimiter characters.
  Returns:
    A string, trimmed.

### nextValue

    public Object nextValue()
                     throws JSONException

  Get the next value. The value can be a Boolean, Double, Integer, JSONArray, JSONObject, Long, or String, or the JSONObject.NULL object.

  Returns:
    An object.
  Throws:
    `JSONException` - If syntax error.

### skipTo

    public char skipTo(char to)

  Skip characters until the next character is the requested character. If the requested character is not found, no characters are skipped.

  Parameters:
    `to` - A character to skip to.
  Returns:
    The requested character, or zero if the requested character is not found.

### skipPast

    public void skipPast(String to)

  Skip characters until past the requested string. If it is not found, we are left at the end of the source.

  Parameters:
    `to` - A string to skip past.

### syntaxError

    public JSONException syntaxError(String message)

  Make a JSONException to signal a syntax error.

  Parameters:
    `message` - The error message.
  Returns:
    A JSONException object, suitable for throwing

### toString

    public String toString()

  Make a printable string of this JSONTokener.

  Overrides:
    `toString` in class `Object`
  Returns:
    " at character [this.myIndex] of [this.mySource]"

Copyright (c) 2005-2009 The Grails project